//***************** (c) 2015 BTC Korporacja ***********************************
//
// http://kamami.com http://kamami.pl
//
//******************************************************************************
//
// DESCRIPTION :
// STM32 library for KAmodHTS221.
//
// COMPILER : WinARM 20060606
//
//******************************************************************************
//
// THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
// BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
// OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
// FROM USE OF THIS SOFTWARE.
//
//******************************************************************************

#include "HTS221_i2c_lib.h"
//#include "stm32f10x_i2c.h"	wersja dla bibliotek CMSIS
#include "stm32f4xx_hal.h"		//wersja dla sterownikw HAL

static unsigned char H0_rH_x2;
static unsigned char H1_rH_x2;
static unsigned short T0_degC_x8;
static unsigned short T1_degC_x8;
 
static short H0_T0_OUT;
static short H1_T0_OUT;
static short T0_OUT;
static short T1_OUT;
 
static float T0_DegC_cal;
static float T1_DegC_cal;
static float H0_RH_cal;
static float H1_RH_cal;

/*
wersja dla bibliotek CMSIS
void HTS221_I2C_HwConfig(void)
{ 
  GPIO_InitTypeDef  GPIO_InitStructure; 
  I2C_InitTypeDef I2C_InitStructure;

  GPIO_InitStructure.GPIO_Pin = HTS221_I2C_SCL | HTS221_I2C_SDA;      
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_OD;
  GPIO_Init(HTS221_I2C_GPIO, &GPIO_InitStructure);

  I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;               
  I2C_InitStructure.I2C_DutyCycle = I2C_DutyCycle_2;        
  I2C_InitStructure.I2C_OwnAddress1 = 0x00;                
  I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;             
  I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit; 
  I2C_InitStructure.I2C_ClockSpeed=HTS221_I2C_SPEED;                  
  I2C_Init(HTS221_I2C_HW,&I2C_InitStructure);

  I2C_Cmd(HTS221_I2C_HW, ENABLE); 
}
 */

/*
 *wersja dla bibliotek CMSIS
void HTS221_I2C_Register_Read(unsigned char regaddr, unsigned char *regval, unsigned char nob)
{
 while(I2C_GetFlagStatus(HTS221_I2C_HW,ENABLE)); 
	if(nob>1)regaddr=regaddr|HTS221_I2C_REG_ADDR_INC;
  I2C_GenerateSTART(HTS221_I2C_HW,ENABLE);
  while(!I2C_CheckEvent(HTS221_I2C_HW, I2C_EVENT_MASTER_MODE_SELECT));  
  I2C_Send7bitAddress(HTS221_I2C_HW, HTS221_I2C_Addr_R, I2C_Direction_Transmitter);
  while(!I2C_CheckEvent(HTS221_I2C_HW, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED));
  I2C_SendData(HTS221_I2C_HW, regaddr);
  while(!I2C_CheckEvent(HTS221_I2C_HW, I2C_EVENT_MASTER_BYTE_TRANSMITTED));

  I2C_GenerateSTART(HTS221_I2C_HW,ENABLE);
  while(!I2C_CheckEvent(HTS221_I2C_HW, I2C_EVENT_MASTER_MODE_SELECT)); 
  I2C_Send7bitAddress(HTS221_I2C_HW, HTS221_I2C_Addr_R, I2C_Direction_Receiver);
  while(!I2C_CheckEvent(HTS221_I2C_HW, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED));
  while(nob)
	{
    if(nob == 1) 
		{
      I2C_AcknowledgeConfig(HTS221_I2C_HW, DISABLE);
      I2C_GenerateSTOP(HTS221_I2C_HW, ENABLE);
    }
    while(!I2C_CheckEvent(HTS221_I2C_HW, I2C_EVENT_MASTER_BYTE_RECEIVED));
		*regval=I2C_ReceiveData(HTS221_I2C_HW);	
		regval++;
    nob--;        
  }
  I2C_AcknowledgeConfig(HTS221_I2C_HW, ENABLE);
}
*/
//wersja dla sterownikw HAL
void HTS221_I2C_Register_Read(unsigned char regaddr, unsigned char *regval, unsigned char nob)
{
uint8_t x;

	if (nob ==1)
	{
		TM_I2C_Read(HTS221_I2C, HTS221_I2C_Addr_R, regaddr, regval);
	}
	else
	{
		for (x=0; x<nob; x++)
		{
			TM_I2C_Read(HTS221_I2C, HTS221_I2C_Addr_R, regaddr+x, regval+x);
		}

	}
	return;
}



/*
 * wersja dla bibliotek CMSIS
void HTS221_I2C_Register_Write(unsigned char regaddr, unsigned char *regval, unsigned char nob)
{
	if(nob>1)regaddr=regaddr|HTS221_I2C_REG_ADDR_INC;
  I2C_GenerateSTART(HTS221_I2C_HW,ENABLE);
  while(!I2C_CheckEvent(HTS221_I2C_HW, I2C_EVENT_MASTER_MODE_SELECT));  
  I2C_Send7bitAddress(HTS221_I2C_HW, HTS221_I2C_Addr_R, I2C_Direction_Transmitter);
  while(!I2C_CheckEvent(HTS221_I2C_HW, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED));
  I2C_SendData(HTS221_I2C_HW, regaddr);
  while(!I2C_CheckEvent(HTS221_I2C_HW, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
	
	while(nob)
	{
  I2C_SendData(HTS221_I2C_HW, *regval);
  while(!I2C_CheckEvent(HTS221_I2C_HW, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
	nob--;
	regval++;
	}
  I2C_GenerateSTOP(HTS221_I2C_HW,ENABLE); 
}
*/
//wersja dla sterownikw HAL
void HTS221_I2C_Register_Write(unsigned char regaddr, unsigned char *regval, unsigned char nob)
{
uint8_t val, x;

	if (nob ==1)
	{
		val =*regval;
		TM_I2C_Write(HTS221_I2C, HTS221_I2C_Addr_W, regaddr, val);
	}
	else
	{
		for (x=0; x<nob; x++)
		{
			val =*(regval+x);
			TM_I2C_Write(HTS221_I2C, HTS221_I2C_Addr_W, regaddr+x, val);
		}
	}
	return;
}

unsigned char HTS221_I2C_Who_Am_I(void)
{
    unsigned char who_am_i[1];
		HTS221_I2C_Register_Read(HTS221_WHO_AM_I, &who_am_i[0], 1);
    if (who_am_i[0] == 0xBC)
		{
			return HTS221_OK;
		}
    else
		{
			return HTS221_ERROR;
		}
}

unsigned char HTS221_I2C_Init(void)
{
  unsigned char RegVal[3];
	
	if(HTS221_I2C_Who_Am_I())
	{
		return HTS221_ERROR;
	}
	
	RegVal[0]=AVGT_16|AVGH_32;
	HTS221_I2C_Register_Write(HTS221_AV_CONF, &RegVal[0], 1);
	
	RegVal[0]=PD_ACTIVE_MODE|BDU_CONTINUOUS_UPDATE_DISABLE|ODR_1HZ;//dla CR1
	RegVal[1]=BOOT_NORMAL_MODE|HEATER_DISABLE|ONE_SHOT_DISABLE;//dla CR2
	RegVal[2]=DRDY_H_L_ACTIVE_HIGH|PP_OD_PP|DRDY_EN_ENABLE;//dla CR3
	HTS221_I2C_Register_Write(HTS221_CTRL_REG1, &RegVal[0], 3);
	
	//HAL_Delay(100);
	HTS221_I2C_Register_Read(HTS221_CTRL_REG1, &RegVal[0], 1);
	RegVal[0]=RegVal[0]&0x87;
	if(RegVal[0]==(PD_ACTIVE_MODE|BDU_CONTINUOUS_UPDATE_DISABLE|ODR_1HZ))
	{
		return HTS221_OK;
	}
  else
	{
		return HTS221_ERROR;
	}
}

void HTS221_I2C_Calib(void) 
{
  unsigned char cal_data[16];
  HTS221_I2C_Register_Read(HTS221_H0_RH_X2, &cal_data[0], 16);
 
  H0_rH_x2 = cal_data[0]; 
  H1_rH_x2 = cal_data[1];
  T0_degC_x8 = ((cal_data[5] & 0x03) << 8) + cal_data[2]; 
  T1_degC_x8 = ((cal_data[5] & 0x0C) << 6) + cal_data[3]; 
 
  H0_T0_OUT = (cal_data[7] << 8) + cal_data[6];  
  H1_T0_OUT = (cal_data[11] << 8) + cal_data[10];
  T0_OUT = (cal_data[13] << 8) + cal_data[12];
  T1_OUT = (cal_data[15] << 8) + cal_data[14];
    
    if (H0_T0_OUT&0x8000) H0_T0_OUT = -1*(0x8000-(0x7fff&H0_T0_OUT));
    if (H1_T0_OUT&0x8000) H1_T0_OUT = -1*(0x8000-(0x7fff&H1_T0_OUT));      
    if (T0_OUT&0x8000) T0_OUT = -1*(0x8000-(0x7fff&T0_OUT));
    if (T1_OUT&0x8000) T1_OUT = -1*(0x8000-(0x7fff&T1_OUT));
    
  T0_DegC_cal = (float) T0_degC_x8/8;
  T1_DegC_cal = (float) T1_degC_x8/8;
  H0_RH_cal = (float) H0_rH_x2/2;
  H1_RH_cal = (float) H1_rH_x2/2;
}

void HTS221_I2C_Read_Temp_Humi( float *pTemp , float *pHumi)
{
	unsigned char sensor_data[4];
  short H_OUT;
  short T_OUT;   
	
	sensor_data[0]=0;
	
	while(!(sensor_data[0]&0x03))
	{
		HTS221_I2C_Register_Read(HTS221_STATUS_REG, &sensor_data[0], 1);
	}
 
  HTS221_I2C_Register_Read(HTS221_HUMIDITY_OUT_L, &sensor_data[0], 4);
    
  H_OUT = (sensor_data[1] << 8) + sensor_data[0];
  T_OUT = (sensor_data[3] << 8) + sensor_data[2];
   
  if (H_OUT&0x8000) H_OUT = -(0x8000-(0x7fff&H_OUT));  
  if (T_OUT&0x8000) T_OUT = -(0x8000-(0x7fff&T_OUT));
    
  *pTemp = HTS221_I2C_Linear_Interpolation(T0_OUT, T0_DegC_cal, T1_OUT, T1_DegC_cal, T_OUT);
  *pHumi = HTS221_I2C_Linear_Interpolation(H0_T0_OUT, H0_RH_cal, H1_T0_OUT, H1_RH_cal, H_OUT);
  if (((int)*pHumi>HTS221_MaxHumi-1) | ((int)*pHumi==-72)) *pHumi = HTS221_MaxHumi;
  if ((int)*pHumi<HTS221_MinHumi ) *pHumi = HTS221_MinHumi;
  if ((int)*pTemp>HTS221_MaxTemp-1) *pTemp = HTS221_MaxTemp; 
  if ((int)*pTemp<HTS221_MinTemp ) *pTemp = HTS221_MinTemp ;  
}


float HTS221_I2C_Linear_Interpolation(short x0, float y0, short x1, float y1, float mes)
{
   float a = (float) ((y1 - y0) / (x1 - x0));
   float b = (float) -a*x0 + y0;
   float cal = (float) a * mes + b;
   return cal;
}

