//***************** (c) 2015 BTC Korporacja ***********************************
//deklaracja dla programu w wersji ze sterownikami HAL
#include "defines.h"
#include "tm_stm32_i2c.h"

//
// http://kamami.com http://kamami.pl
//
//******************************************************************************
//
// DESCRIPTION :
// STM32 library for KAmodHTS221.
//
// COMPILER : WinARM 20060606
//
//******************************************************************************
//
// THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
// BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
// OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
// FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
/*
deklaracje niezbdne dla programu w wersji z bibliotekami CMSIS
#define HTS221_I2C_HW	I2C1 //STM hardware I2C

#define HTS221_I2C_SPEED 10000 //I2C Speed

#define HTS221_I2C_GPIO GPIOB //STM32 port setting

#define HTS221_I2C_SCL GPIO_Pin_6 //STM32 SCL pin setting
#define HTS221_I2C_SDA GPIO_Pin_7 //STM32 SDA pin setting
#define HTS221_I2C_CS GPIO_Pin_0 //STM32 CS pin setting
#define HTS221_I2C_DRDY GPIO_Pin_1 //STM32 DRDY pin setting
*/

#define HTS221_MaxTemp	120 //Maximal temperature value
#define HTS221_MinTemp	-40 //Minimal temperature value
#define HTS221_MaxHumi 100 //Maximal humidity value
#define HTS221_MinHumi	0 //Minimal humidity value

#define HTS221_ERROR 1 //Status HTS221
#define HTS221_OK 	0 //Status HTS221

#define HTS221_I2C_Addr_R 0xBF //SHT221 I2C read adrees
#define HTS221_I2C_Addr_W 0xBE //SHT221 I2C write adrees

#define HTS221_I2C_REG_ADDR_NO_INC 0x00	//Disable adress increment.

#define HTS221_I2C_REG_ADDR_INC 0x80 //Enable adress increment.

//*************************************************************************************************************//
//Device identification//
//This read-only register contains the device identifier, set to BCh//
//[7:0] Number ID = 0xBC

#define HTS221_WHO_AM_I 0x0F	//	R-0xBC
//*************************************************************************************************************//



//*************************************************************************************************************//
//Humidity and temperature resolution mode//
//To configure humidity/temperature average.//
//[7:6]  Reserved//
//[5:3]  AVGT2-0: To select the numbers of averaged temperature samples (2 - 256)//
//[2:0]  AVGH2-0: To select the numbers of averaged humidity samples (4 - 512)//

#define HTS221_AV_CONF 0x10	//	 R/W-0x1B	

#define AVGT_2 0x00	//Noise_(RMS)_Temp(C)_0.08	IDD_1_Hz(uA)_0.80	
#define AVGT_4 0x08	//Noise_(RMS)_Temp(C)_0.05	IDD_1_Hz(uA)_1.05
#define AVGT_8 0x10	//Noise_(RMS)_Temp(C)_0.04	IDD_1_Hz(uA)_1.40
#define AVGT_16 0x18	//Noise_(RMS)_Temp(C)_0.03	IDD_1_Hz(uA)_2.10	Default
#define AVGT_32 0x20	//Noise_(RMS)_Temp(C)_0.02	IDD_1_Hz(uA)_3.43
#define AVGT_64 0x28	//Noise_(RMS)_Temp(C)_0.015	IDD_1_Hz(uA)_6.15
#define AVGT_128 0x30	//Noise_(RMS)_Temp(C)_0.01	IDD_1_Hz(uA)_11.60
#define AVGT_256 0x38	//Noise_(RMS)_Temp(C)_0.007	IDD_1_Hz(uA)_22.50

#define AVGH_4 0x00	//Noise_(RMS)_rH(%)_0.4	IDD_1_Hz(uA)_0.80	
#define AVGH_8 0x01	//Noise_(RMS)_rH(%)_0.3	IDD_1_Hz(uA)_1.05
#define AVGH_16 0x02	//Noise_(RMS)_rH(%)_0.2	IDD_1_Hz(uA)_1.40	
#define AVGH_32 0x03	//Noise_(RMS)_rH(%)_0.15	IDD_1_Hz(uA)_2.10	Default
#define AVGH_64 0x04	//Noise_(RMS)_rH(%)_0.1	IDD_1_Hz(uA)_3.43	
#define AVGH_128 0x05	//Noise_(RMS)_rH(%)_0.07	IDD_1_Hz(uA)_6.15	
#define AVGH_256 0x06	//Noise_(RMS)_rH(%)_0.05	IDD_1_Hz(uA)_11.60	
#define AVGH_512 0x07	//Noise_(RMS)_rH(%)_0.03	IDD_1_Hz(uA)_22.50
//*************************************************************************************************************//



//*************************************************************************************************************//
//Control register 1//
//Control register//
//[7]  PD: power down control//
//[6:3]  Reserved//
//[2]  BDU: block data update//
//[1:0]  ODR1, ODR0: output data rate selection//

#define HTS221_CTRL_REG1 0x20	//	R/W-0x00

#define PD_POWER_DOWN 0x00	//power-down mode//
#define PD_ACTIVE_MODE 0x80	//active mode//

#define BDU_CONTINUOUS_UPDATE_ENABLE 0x00	//continuous update//
#define BDU_CONTINUOUS_UPDATE_DISABLE 0x04	//output registers not updated until MSB and LSB reading//

#define ODR_OS 0x00 //One shot
#define ODR_1HZ 0x01 //1Hz
#define ODR_7HZ 0x02 //7Hz
#define ODR_12_5HZ 0x03 //12.5Hz
//*************************************************************************************************************//



//*************************************************************************************************************//
//Control register 2//
//Control register//
//[7]  BOOT: Reboot memory content//
//[6:2]  Reserved//
//[1]  Heater//
//[0]  One shot//

#define HTS221_CTRL_REG2 0x21	//	R/W-0x00

#define BOOT_NORMAL_MODE 0x00 //normal mode//
#define BOOT_REBOOT 0x80	//reboot memory content//

#define HEATER_DISABLE 0x00	//heater disable//
#define HEATER_ENABLE 0x02	//heater enable//
//Vdd[V]	I[mA]//
//3.3			33
//2.5			22
//1.8			12

#define ONE_SHOT_DISABLE 0x00 //waiting for start of conversion//
#define ONE_SHOT_ENABLE 0x01	//start for a new dataset//
//*************************************************************************************************************//



//*************************************************************************************************************//
//Control register 3//
//Control register for data ready output signal//
//[7]  DRDY_H_L: Data Ready output signal active high, low//
//[6]  PP_OD: Push-pull / Open Drain selection on pin 3 (DRDY)//
//[5:3]  Reserved//
//[2]  DRDY_EN: Data Ready enable//
//[1:0]  Reserved//

#define HTS221_CTRL_REG3 0x22	//	R/W-0x00

#define DRDY_H_L_ACTIVE_HIGH 0x00	//active high - default//
#define DRDY_H_L_ACTIVE_LOW 0x80	//active low//

#define PP_OD_PP 0x00 //push-pull - default//
#define PP_OD_OD 0x40 //open drain//

#define DRDY_EN_DISABLED 0x00	//Data Ready disabled - default//
#define DRDY_EN_ENABLE 0x04	//Data Ready signal available on pin 3//
//*************************************************************************************************************//



//*************************************************************************************************************//
//Status register//
//Status register; the content of this register is updated every one-shot reading,//
//and after completion of every ODR cycle, regardless of BDU value in CTRL_REG1//
//[7:2]  Reserved//
//[1]  H_DA: Humidity data available. (0: new data for Humidity is not yet available; 1: new data for Humidity is available)//
//[0]  T_DA: Temperature data available. (0: new data for temperature is not yet available; 1: new data for temperature is available)//

#define HTS221_STATUS_REG 0x27	//	R-0x00
//*************************************************************************************************************//



//*************************************************************************************************************//
//Relative humidity data (LSB)//
//Humidity data (see HUMIDITY_OUT_H)//
//[7:0]  HOUT7 - HOUT0: Humidity data LSB//

#define HTS221_HUMIDITY_OUT_L 0x28	//	R-Data
//*************************************************************************************************************//



//*************************************************************************************************************//
//Relative humidity data (MSB)//
//Humidity data are expressed as HUMIDITY_OUT_H & HUMIDITY_OUT_L in 2s complement.//
//Values exceeding the operating humidity range (0-100) must be clipped by SW. //
//[7:0]  HOUT15 - HOUT8: Humidity data MSB//

#define HTS221_HUMIDITY_OUT_H 0x29	//	R-Data
//*************************************************************************************************************//



//*************************************************************************************************************//
//Temperature data (LSB)//	
//[7:0]  TOUT7 - TOUT0: Temperature data LSB (see TEMPERATURE_OUT_H)//

#define HTS221_TEMP_OUT_L 0x2A	//	R-Data
//*************************************************************************************************************//



//*************************************************************************************************************//
//Temperature data (MSB)//
//[15:8]  TOUT15 - TOUT8: Temperature data MSB.//

#define HTS221_TEMP_OUT_H 0x2B	//	R-Data
//*************************************************************************************************************//



//*************************************************************************************************************//
//Calibration Registers//

//[7:0]	H0.7 - H0.0	// Calibration data
#define HTS221_H0_RH_X2 0x30	//	R/W-Do not modify

//[7:0]	H1.7 - H1.0	// Calibration data
#define HTS221_H1_RH_X2 0x31	//	R/W-Do not modify

//[7:0]	T0.7 - T0.0	// Calibration data
#define HTS221_T0_DEGC_X8 0x32	//	R/W-Do not modify

//[7:0]	T1.7 - T1.0	// Calibration data
#define HTS221_T1_DEGC_X8 0x33	//	R/W-Do not modify

//[1:0]	T0.9 - T0.8	// Calibration data
//[3:2] T1.9 - T1.8 // Calibration data
//[7:4] Const 0
#define HTS221_T1_T0_MSB 0x35	//	R/W-Do not modify

//[7:0] Calibration data
#define HTS221_H0_T0_OUT_L 0x36	//	R/W-Do not modify

//[7:0] 15-8 //Calibration data
#define HTS221_H0_T0_OUT_H 0x37	//	R/W-Do not modify

//[7:0] 7-0 //Calibration data
#define HTS221_H1_T0_OUT_L 0x3A	//	R/W-Do not modify

//[7:0] 15-8 //Calibration data
#define HTS221_H1_T0_OUT_H 0x3B	//	R/W-Do not modify

//[7:0] 7-0 //Calibration data
#define HTS221_T0_OUT_L 0x3C	//	R/W-Do not modify

//[7:0] 15-8 //Calibration data
#define HTS221_T0_OUT_H 0x3D	//	R/W-Do not modify

//[7:0] 7-0 //Calibration data
#define HTS221_T1_OUT_L 0x3E	//	R/W-Do not modify

//[7:0] 15-8 //Calibration data
#define HTS221_T1_OUT_H 0x3F	//	R/W-Do not modify
//********************************************************************************************************//



//*************************************************************************************************************//
//Hawdware configuration for HTS221 (I2C)//
//Set port and microcontroller pins to work with I2C line//
//Set the speed of the I2C//
/*
wersja dla bibliotek CMSIS
void HTS221_I2C_HwConfig(void); 
 */
//************************************************************************************************************//



//************************************************************************************************************//
//Reads one ("nob"=1) or few ("nob">1) 8-bits registers from HTS221 via I2C, started from "regaddr" adress.//
//Value of the registers are saved under pointer "*regval" //
//"nob" is number of bits to read and must be <= number of elements of the declared array variables to store the register value.

void HTS221_I2C_Register_Read(unsigned char regaddr, unsigned char *regval, unsigned char nob);
//*************************************************************************************************************//



//*************************************************************************************************************//
//Save one ("nob"=1) or few ("nob">1) 8-bits registers in to HTS221 via I2C, started from "regaddr" adress.//
//Value unter the pointer "*regval" are saved to sensor register. //
//"nob" is number of bits to save and must be <= number of elements of the declared array variables with new register value.

void HTS221_I2C_Register_Write(unsigned char regaddr, unsigned char *regval, unsigned char nob);
//*************************************************************************************************************//



//*************************************************************************************************************//
//Function checks sensor Id, if is correct return 0 else 1//

unsigned char HTS221_I2C_Who_Am_I(void);
//*************************************************************************************************************//



//*************************************************************************************************************//
//checks sensor Id//
//Set control register and verifity it//
//If veryvication is succesfull return 0 else 1

unsigned char HTS221_I2C_Init(void);
//*************************************************************************************************************//



//*************************************************************************************************************//
//Read all config register from HTS221 and format it.//

void HTS221_I2C_Calib(void);
//*************************************************************************************************************//



//*************************************************************************************************************//
//Save temperature value under pointer "*pTemp"//
//Save humidity value under pointer "*pHumi"//

void HTS221_I2C_Read_Temp_Humi( float *pTemp , float *pHumi);
//*************************************************************************************************************//



//*************************************************************************************************************//
//Make linear interpolation for argument "mes" based on calibration const from sensor x0, y0 and x1,y1 and return correct value.

float HTS221_I2C_Linear_Interpolation(short x0, float y0, short x1, float y1, float mes);
//*************************************************************************************************************//
