/**
  ******************************************************************************
  * File Name          : main.c
  * Description        : Main program body
  ******************************************************************************
  *
  * COPYRIGHT(c) 2016 STMicroelectronics
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "stm32f4xx_hal.h"

/* USER CODE BEGIN Includes */
#include "tm_stm32_ssd1306.h"
#include "HTS221_i2c_lib.h"
/* USER CODE END Includes */

/* Private variables ---------------------------------------------------------*/
I2C_HandleTypeDef hi2c1;

/* USER CODE BEGIN PV */
/* Private variables ---------------------------------------------------------*/
float tempCelsius = 25.50;
float humi = 55;

char tmp_char[20];
unsigned char z;
GPIO_PinState stan_HTS221_DRDY;
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_I2C1_Init(void);

/* USER CODE BEGIN PFP */
/* Private function prototypes -----------------------------------------------*/

/* USER CODE END PFP */

/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

int main(void)
{

  /* USER CODE BEGIN 1 */
int tmp_int;
unsigned char tmp_uchar;
  /* USER CODE END 1 */

  /* MCU Configuration----------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* Configure the system clock */
  SystemClock_Config();

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_I2C1_Init();

  /* USER CODE BEGIN 2 */
  /* Init SSD1306 LCD 128 x 64 px */
  if (TM_SSD1306_Init()) {
      /* SSD1306 is connected */
	  TM_SSD1306_GotoXY(30, 4);
  } else {
      /* SSD1306 is not connected */
	  //TM_SSD1306_GotoXY(30, 4);
  }

  TM_SSD1306_GotoXY(8, 4);
  TM_SSD1306_Puts("HTS221 sensor", &TM_Font_7x10, SSD1306_COLOR_WHITE);
  TM_SSD1306_GotoXY(8, 20);
  TM_SSD1306_Puts("temperatury i", &TM_Font_7x10, SSD1306_COLOR_WHITE);
  TM_SSD1306_GotoXY(8, 36);
  TM_SSD1306_Puts("wilgotnosci", &TM_Font_7x10, SSD1306_COLOR_WHITE);

  /* Update screen, send changes to LCD */
  TM_SSD1306_UpdateScreen();
  HAL_Delay(2000);

  TM_SSD1306_Fill(SSD1306_COLOR_BLACK);
  TM_SSD1306_GotoXY(8, 4);
  TM_SSD1306_Puts("HTS221 sensor", &TM_Font_7x10, SSD1306_COLOR_WHITE);
  TM_SSD1306_GotoXY(8, 20);
  TM_SSD1306_Puts("[T 'C]:", &TM_Font_7x10, SSD1306_COLOR_WHITE);
  TM_SSD1306_GotoXY(8, 36);
  TM_SSD1306_Puts("[RH %]:", &TM_Font_7x10, SSD1306_COLOR_WHITE);
  TM_SSD1306_UpdateScreen();


  if(HTS221_I2C_Init())
	{
	  TM_SSD1306_GotoXY(15, 52);
	  TM_SSD1306_Puts("ID bledny", &TM_Font_7x10, SSD1306_COLOR_WHITE);
	  /* Update screen, send changes to LCD */
	  TM_SSD1306_UpdateScreen();

	  while(1);
	}
  else
  {
	  TM_SSD1306_GotoXY(15, 52);
	  TM_SSD1306_Puts("ID prawidlowy", &TM_Font_7x10, SSD1306_COLOR_WHITE);
	  /* Update screen, send changes to LCD */
	  TM_SSD1306_UpdateScreen();

  }
  HTS221_I2C_Calib();

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  z =0;
  while (1)
  {

  /* USER CODE END WHILE */

  /* USER CODE BEGIN 3 */
	  	 stan_HTS221_DRDY =HAL_GPIO_ReadPin(HTS221_DRDY_Port, HTS221_DRDY_Pin);
	  	  while (stan_HTS221_DRDY ==GPIO_PIN_RESET)
	  	  {
	  		z++;
	  		HAL_Delay(10);
	  		if(z==200)
	  		{
	  			TM_SSD1306_GotoXY(15, 52);
	  			TM_SSD1306_Puts("blad DRDY", &TM_Font_7x10, SSD1306_COLOR_WHITE);
	  			// Update screen, send changes to LCD
	  			TM_SSD1306_UpdateScreen();
	  			while (1);
	  		}
			TM_SSD1306_GotoXY(15, 52);
			TM_SSD1306_Puts("pomiar        ", &TM_Font_7x10, SSD1306_COLOR_WHITE);
			// Update screen, send changes to LCD
			TM_SSD1306_UpdateScreen();

	  		stan_HTS221_DRDY =HAL_GPIO_ReadPin(HTS221_DRDY_Port, HTS221_DRDY_Pin);
	  	  }
			TM_SSD1306_GotoXY(15, 52);
			TM_SSD1306_Puts("odczyt        ", &TM_Font_7x10, SSD1306_COLOR_WHITE);
			// Update screen, send changes to LCD
			TM_SSD1306_UpdateScreen();

			HTS221_I2C_Read_Temp_Humi(&tempCelsius, &humi);

			tmp_int =(tempCelsius *10);
			tmp_uchar =tmp_int % 10;
			//snprintf(&tmp_char[0], 20, "[T 'C]: %3.3f  ", tempCelsius);
			snprintf(&tmp_char[0], 20, "[T 'C]: %2d,%d  ", (int)tempCelsius,tmp_uchar);
			TM_SSD1306_GotoXY(8, 20);
			TM_SSD1306_Puts(&tmp_char[0], &TM_Font_7x10, SSD1306_COLOR_WHITE);
			//snprintf(&tmp_char[0], 20, "[RH %]: %3.3f  ", humi);
			snprintf(&tmp_char[0], 20, "[RH %c]: %d  ", '%',(int)humi);
			TM_SSD1306_GotoXY(8, 36);
			TM_SSD1306_Puts(&tmp_char[0], &TM_Font_7x10, SSD1306_COLOR_WHITE);
			TM_SSD1306_UpdateScreen();

	  	  z =0;

  }
  /* USER CODE END 3 */

}

/** System Clock Configuration
*/
void SystemClock_Config(void)
{

  RCC_OscInitTypeDef RCC_OscInitStruct;
  RCC_ClkInitTypeDef RCC_ClkInitStruct;

  __PWR_CLK_ENABLE();

  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_BYPASS;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 4;
  RCC_OscInitStruct.PLL.PLLN = 84;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  HAL_RCC_OscConfig(&RCC_OscInitStruct);

  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;
  HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2);

  HAL_SYSTICK_Config(HAL_RCC_GetHCLKFreq()/1000);

  HAL_SYSTICK_CLKSourceConfig(SYSTICK_CLKSOURCE_HCLK);

  /* SysTick_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(SysTick_IRQn, 0, 0);
}

/* I2C1 init function */
void MX_I2C1_Init(void)
{

  hi2c1.Instance = I2C1;
  hi2c1.Init.ClockSpeed = 100000;
  hi2c1.Init.DutyCycle = I2C_DUTYCYCLE_2;
  hi2c1.Init.OwnAddress1 = 0;
  hi2c1.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
  hi2c1.Init.DualAddressMode = I2C_DUALADDRESS_DISABLED;
  hi2c1.Init.OwnAddress2 = 0;
  hi2c1.Init.GeneralCallMode = I2C_GENERALCALL_DISABLED;
  hi2c1.Init.NoStretchMode = I2C_NOSTRETCH_DISABLED;
  HAL_I2C_Init(&hi2c1);

}

/** Configure pins as 
        * Analog 
        * Input 
        * Output
        * EVENT_OUT
        * EXTI
*/
void MX_GPIO_Init(void)
{

  GPIO_InitTypeDef GPIO_InitStruct;

  /* GPIO Ports Clock Enable */
  __GPIOC_CLK_ENABLE();
  __GPIOH_CLK_ENABLE();
  __GPIOA_CLK_ENABLE();
  __GPIOB_CLK_ENABLE();

  /*Configure GPIO pin : B1_Pin */
  GPIO_InitStruct.Pin = B1_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_EVT_RISING;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(B1_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pin : LD2_Pin */
  GPIO_InitStruct.Pin = LD2_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_LOW;
  HAL_GPIO_Init(LD2_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pin : HTS221_DRDY_Pin */
  GPIO_InitStruct.Pin = HTS221_DRDY_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  HAL_GPIO_Init(HTS221_DRDY_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(LD2_GPIO_Port, LD2_Pin, GPIO_PIN_RESET);

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

#ifdef USE_FULL_ASSERT

/**
   * @brief Reports the name of the source file and the source line number
   * where the assert_param error has occurred.
   * @param file: pointer to the source file name
   * @param line: assert_param error line source number
   * @retval None
   */
void assert_failed(uint8_t* file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
    ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */

}

#endif

/**
  * @}
  */ 

/**
  * @}
*/ 

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
